/* rygel-gst-launch-video-item.c generated by valac 0.32.0, the Vala compiler
 * generated from rygel-gst-launch-video-item.vala, do not modify */

/*
 * Copyright (C) 2009 Thijs Vermeir <thijsvermeir@gmail.com>
 * Copyright (C) 2010 Nokia Corporation.
 * Copyright (C) 2012 Intel Corporation.
 *
 * Author: Thijs Vermeir <thijsvermeir@gmail.com>
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *         Jens Georg <jensg@openismus.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <glib.h>
#include <glib-object.h>
#include <rygel-server.h>
#include <stdlib.h>
#include <string.h>
#include <libsoup/soup.h>


#define RYGEL_GST_LAUNCH_TYPE_VIDEO_ITEM (rygel_gst_launch_video_item_get_type ())
#define RYGEL_GST_LAUNCH_VIDEO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_GST_LAUNCH_TYPE_VIDEO_ITEM, RygelGstLaunchVideoItem))
#define RYGEL_GST_LAUNCH_VIDEO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_GST_LAUNCH_TYPE_VIDEO_ITEM, RygelGstLaunchVideoItemClass))
#define RYGEL_GST_LAUNCH_IS_VIDEO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_GST_LAUNCH_TYPE_VIDEO_ITEM))
#define RYGEL_GST_LAUNCH_IS_VIDEO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_GST_LAUNCH_TYPE_VIDEO_ITEM))
#define RYGEL_GST_LAUNCH_VIDEO_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_GST_LAUNCH_TYPE_VIDEO_ITEM, RygelGstLaunchVideoItemClass))

typedef struct _RygelGstLaunchVideoItem RygelGstLaunchVideoItem;
typedef struct _RygelGstLaunchVideoItemClass RygelGstLaunchVideoItemClass;
typedef struct _RygelGstLaunchVideoItemPrivate RygelGstLaunchVideoItemPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _RygelGstLaunchVideoItem {
	RygelVideoItem parent_instance;
	RygelGstLaunchVideoItemPrivate * priv;
};

struct _RygelGstLaunchVideoItemClass {
	RygelVideoItemClass parent_class;
};


static gpointer rygel_gst_launch_video_item_parent_class = NULL;

GType rygel_gst_launch_video_item_get_type (void) G_GNUC_CONST;
enum  {
	RYGEL_GST_LAUNCH_VIDEO_ITEM_DUMMY_PROPERTY
};
RygelGstLaunchVideoItem* rygel_gst_launch_video_item_new (const gchar* id, RygelMediaContainer* parent, const gchar* title, const gchar* mime_type, const gchar* launch_line);
RygelGstLaunchVideoItem* rygel_gst_launch_video_item_construct (GType object_type, const gchar* id, RygelMediaContainer* parent, const gchar* title, const gchar* mime_type, const gchar* launch_line);


RygelGstLaunchVideoItem* rygel_gst_launch_video_item_construct (GType object_type, const gchar* id, RygelMediaContainer* parent, const gchar* title, const gchar* mime_type, const gchar* launch_line) {
	RygelGstLaunchVideoItem * self = NULL;
	const gchar* _tmp0_ = NULL;
	RygelMediaContainer* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	g_return_val_if_fail (id != NULL, NULL);
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (mime_type != NULL, NULL);
	g_return_val_if_fail (launch_line != NULL, NULL);
	_tmp0_ = id;
	_tmp1_ = parent;
	_tmp2_ = title;
	self = (RygelGstLaunchVideoItem*) rygel_video_item_construct (object_type, _tmp0_, _tmp1_, _tmp2_, RYGEL_VIDEO_ITEM_UPNP_CLASS);
	_tmp3_ = mime_type;
	rygel_media_file_item_set_mime_type ((RygelMediaFileItem*) self, _tmp3_);
	_tmp4_ = launch_line;
	_tmp5_ = soup_uri_encode (_tmp4_, ".!");
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat ("gst-launch://", _tmp6_, NULL);
	_tmp8_ = _tmp7_;
	rygel_media_object_add_uri ((RygelMediaObject*) self, _tmp8_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	return self;
}


RygelGstLaunchVideoItem* rygel_gst_launch_video_item_new (const gchar* id, RygelMediaContainer* parent, const gchar* title, const gchar* mime_type, const gchar* launch_line) {
	return rygel_gst_launch_video_item_construct (RYGEL_GST_LAUNCH_TYPE_VIDEO_ITEM, id, parent, title, mime_type, launch_line);
}


static void rygel_gst_launch_video_item_class_init (RygelGstLaunchVideoItemClass * klass) {
	rygel_gst_launch_video_item_parent_class = g_type_class_peek_parent (klass);
}


static void rygel_gst_launch_video_item_instance_init (RygelGstLaunchVideoItem * self) {
}


/**
 * Video item that serves data from a gst-launch commandline.
 */
GType rygel_gst_launch_video_item_get_type (void) {
	static volatile gsize rygel_gst_launch_video_item_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_gst_launch_video_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelGstLaunchVideoItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_gst_launch_video_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelGstLaunchVideoItem), 0, (GInstanceInitFunc) rygel_gst_launch_video_item_instance_init, NULL };
		GType rygel_gst_launch_video_item_type_id;
		rygel_gst_launch_video_item_type_id = g_type_register_static (RYGEL_TYPE_VIDEO_ITEM, "RygelGstLaunchVideoItem", &g_define_type_info, 0);
		g_once_init_leave (&rygel_gst_launch_video_item_type_id__volatile, rygel_gst_launch_video_item_type_id);
	}
	return rygel_gst_launch_video_item_type_id__volatile;
}



